diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/arp-header.cc ns-3.36/src/internet/model/arp-header.cc
--- ns-3.35/src/internet/model/arp-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/arp-header.cc	2022-04-30 18:23:57.858733400 -0700
@@ -29,7 +29,7 @@
 
 NS_OBJECT_ENSURE_REGISTERED (ArpHeader);
 
-void 
+void
 ArpHeader::SetRequest (Address sourceHardwareAddress,
                        Ipv4Address sourceProtocolAddress,
                        Address destinationHardwareAddress,
@@ -42,7 +42,7 @@
   m_ipv4Source = sourceProtocolAddress;
   m_ipv4Dest = destinationProtocolAddress;
 }
-void 
+void
 ArpHeader::SetReply (Address sourceHardwareAddress,
                      Ipv4Address sourceProtocolAddress,
                      Address destinationHardwareAddress,
@@ -55,37 +55,37 @@
   m_ipv4Source = sourceProtocolAddress;
   m_ipv4Dest = destinationProtocolAddress;
 }
-bool 
+bool
 ArpHeader::IsRequest (void) const
 {
   NS_LOG_FUNCTION (this);
-  return (m_type == ARP_TYPE_REQUEST) ? true : false;
+  return m_type == ARP_TYPE_REQUEST;
 }
-bool 
+bool
 ArpHeader::IsReply (void) const
 {
   NS_LOG_FUNCTION (this);
-  return (m_type == ARP_TYPE_REPLY) ? true : false;
+  return m_type == ARP_TYPE_REPLY;
 }
-Address 
+Address
 ArpHeader::GetSourceHardwareAddress (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_macSource;
 }
-Address 
+Address
 ArpHeader::GetDestinationHardwareAddress (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_macDest;
 }
-Ipv4Address 
+Ipv4Address
 ArpHeader::GetSourceIpv4Address (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_ipv4Source;
 }
-Ipv4Address 
+Ipv4Address
 ArpHeader::GetDestinationIpv4Address (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -93,7 +93,7 @@
 }
 
 
-TypeId 
+TypeId
 ArpHeader::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ArpHeader")
@@ -103,28 +103,28 @@
   ;
   return tid;
 }
-TypeId 
+TypeId
 ArpHeader::GetInstanceTypeId (void) const
 {
   NS_LOG_FUNCTION (this);
   return GetTypeId ();
 }
-void 
+void
 ArpHeader::Print (std::ostream &os) const
 {
   NS_LOG_FUNCTION (this << &os);
-  if (IsRequest ()) 
+  if (IsRequest ())
     {
       os << "request "
          << "source mac: " << m_macSource << " "
          << "source ipv4: " << m_ipv4Source << " "
          << "dest ipv4: " << m_ipv4Dest
       ;
-    } 
-  else 
+    }
+  else
     {
       NS_ASSERT (IsReply ());
-      os << "reply " 
+      os << "reply "
          << "source mac: " << m_macSource << " "
          << "source ipv4: " << m_ipv4Source << " "
          << "dest mac: " << m_macDest << " "
@@ -132,7 +132,7 @@
       ;
     }
 }
-uint32_t 
+uint32_t
 ArpHeader::GetSerializedSize (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -178,7 +178,7 @@
   //
   // It is implicit here that we have a protocol type of 0x800 (IP).
   // It is also implicit here that we are using Ipv4 (PLN == 4).
-  // If this isn't the case, we need to return an error since we don't want to 
+  // If this isn't the case, we need to return an error since we don't want to
   // be too fragile if we get connected to real networks.
   //
   if (protocolType != 0x800 || protocolAddressLen != 4)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/arp-l3-protocol.h ns-3.36/src/internet/model/arp-l3-protocol.h
--- ns-3.35/src/internet/model/arp-l3-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/arp-l3-protocol.h	2022-04-30 18:23:57.858733400 -0700
@@ -63,6 +63,10 @@
   ArpL3Protocol ();
   virtual ~ArpL3Protocol ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  ArpL3Protocol (const ArpL3Protocol &) = delete;
+  ArpL3Protocol & operator = (const ArpL3Protocol &) = delete;
+
   /**
    * \brief Set the node the ARP L3 protocol is associated with
    * \param node the node
@@ -128,21 +132,6 @@
   virtual void NotifyNewAggregate ();
 private:
   typedef std::list<Ptr<ArpCache> > CacheList; //!< container of the ARP caches
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \param o
-   */
-  ArpL3Protocol (const ArpL3Protocol &o);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \param o
-   * \returns
-   */
-  ArpL3Protocol &operator = (const ArpL3Protocol &o);
 
   /**
    * \brief Finds the cache associated with a NetDevice
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/arp-queue-disc-item.h ns-3.36/src/internet/model/arp-queue-disc-item.h
--- ns-3.35/src/internet/model/arp-queue-disc-item.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/arp-queue-disc-item.h	2022-04-30 18:23:57.858733400 -0700
@@ -44,8 +44,14 @@
    */
   ArpQueueDiscItem (Ptr<Packet> p, const Address & addr, uint16_t protocol, const ArpHeader & header);
 
+  /** Destructor. */
   virtual ~ArpQueueDiscItem ();
 
+  // Delete default constructor, copy constructor and assignment operator to avoid misuse
+  ArpQueueDiscItem () = delete;
+  ArpQueueDiscItem (const ArpQueueDiscItem &) = delete;
+  ArpQueueDiscItem & operator = (const ArpQueueDiscItem &) = delete;
+
   /**
    * \return the correct packet size (header plus payload).
    */
@@ -82,28 +88,8 @@
   virtual uint32_t Hash (uint32_t perturbation) const;
 
 private:
-  /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  ArpQueueDiscItem ();
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  ArpQueueDiscItem (const ArpQueueDiscItem &);
-  /**
-   * \brief Assignment operator
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  ArpQueueDiscItem &operator = (const ArpQueueDiscItem &);
-
   ArpHeader m_header;  //!< The ARP header.
-  bool m_headerAdded;   //!< True if the header has already been added to the packet.
+  bool m_headerAdded;  //!< True if the header has already been added to the packet.
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/icmpv6-header.cc ns-3.36/src/internet/model/icmpv6-header.cc
--- ns-3.35/src/internet/model/icmpv6-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/icmpv6-header.cc	2022-04-30 18:23:57.862733600 -0700
@@ -1069,17 +1069,11 @@
   NS_LOG_FUNCTION (this);
 }
 
-Ptr<Packet> Icmpv6DestinationUnreachable::GetPacket () const
-{
-  NS_LOG_FUNCTION (this);
-  return m_packet;
-}
-
 void Icmpv6DestinationUnreachable::SetPacket (Ptr<Packet> p)
 {
   NS_LOG_FUNCTION (this << *p);
   NS_ASSERT (p->GetSize () <= 1280);
-  m_packet = p;
+  m_packet = p->Copy ();
 }
 
 void Icmpv6DestinationUnreachable::Print (std::ostream& os) const
@@ -1091,7 +1085,9 @@
 uint32_t Icmpv6DestinationUnreachable::GetSerializedSize () const
 {
   NS_LOG_FUNCTION (this);
-  return 8 + m_packet->GetSize ();
+  // The real size of the header is 8 + m_packet->GetSize ()
+  // HOWEVER we just serialize the first 8 bytes, as the rest is serialized separately.
+  return 8;
 }
 
 void Icmpv6DestinationUnreachable::Serialize (Buffer::Iterator start) const
@@ -1100,40 +1096,40 @@
   uint16_t checksum = 0;
   Buffer::Iterator i = start;
 
-  i.WriteU8 (GetType ());
-  i.WriteU8 (GetCode ());
-  i.WriteHtonU16 (0);
-  i.WriteHtonU32 (0);
+  Buffer secondaryBuffer;
+  secondaryBuffer.AddAtStart (8 + m_packet->GetSize ());
+  Buffer::Iterator iter = secondaryBuffer.Begin ();
+
+  iter.WriteU8 (GetType ());
+  iter.WriteU8 (GetCode ());
+  iter.WriteU16 (0);
+  iter.WriteU32 (0);
 
   uint32_t size = m_packet->GetSize ();
   uint8_t *buf = new uint8_t[size];
   m_packet->CopyData (buf, size);
-  i.Write (buf, size);
+  iter.Write (buf, size);
   delete[] buf;
 
-  i = start;
-  checksum = i.CalculateIpChecksum (i.GetSize (), GetChecksum ());
+  iter = secondaryBuffer.Begin ();
+  checksum = iter.CalculateIpChecksum (iter.GetSize (), GetChecksum ());
 
-  i = start;
-  i.Next (2);
+  i.WriteU8 (GetType ());
+  i.WriteU8 (GetCode ());
   i.WriteU16 (checksum);
+  i.WriteU32 (0);
 }
 
 uint32_t Icmpv6DestinationUnreachable::Deserialize (Buffer::Iterator start)
 {
   NS_LOG_FUNCTION (this << &start);
-  uint16_t length = start.GetRemainingSize () - 8;
-  uint8_t* data = new uint8_t[length];
   Buffer::Iterator i = start;
 
   SetType (i.ReadU8 ());
   SetCode (i.ReadU8 ());
   m_checksum = i.ReadU16 ();
-  i.ReadNtohU32 ();
-  i.Read (data, length);
-  m_packet = Create<Packet> (data, length);
+  i.ReadU32 ();
 
-  delete[] data;
   return GetSerializedSize ();
 }
 
@@ -1168,17 +1164,11 @@
   NS_LOG_FUNCTION (this);
 }
 
-Ptr<Packet> Icmpv6TooBig::GetPacket () const
-{
-  NS_LOG_FUNCTION (this);
-  return m_packet;
-}
-
 void Icmpv6TooBig::SetPacket (Ptr<Packet> p)
 {
   NS_LOG_FUNCTION (this << *p);
   NS_ASSERT (p->GetSize () <= 1280);
-  m_packet = p;
+  m_packet = p->Copy ();
 }
 
 uint32_t Icmpv6TooBig::GetMtu () const
@@ -1202,7 +1192,9 @@
 uint32_t Icmpv6TooBig::GetSerializedSize () const 
 {
   NS_LOG_FUNCTION (this);
-  return 8 + m_packet->GetSize ();
+  // The real size of the header is 8 + m_packet->GetSize ()
+  // HOWEVER we just serialize the first 8 bytes, as the rest is serialized separately.
+  return 8;
 }
 
 void Icmpv6TooBig::Serialize (Buffer::Iterator start) const
@@ -1211,40 +1203,40 @@
   uint16_t checksum = 0;
   Buffer::Iterator i = start;
 
-  i.WriteU8 (GetType ());
-  i.WriteU8 (GetCode ());
-  i.WriteHtonU16 (0);
-  i.WriteHtonU32 (GetMtu ());
+  Buffer secondaryBuffer;
+  secondaryBuffer.AddAtStart (8 + m_packet->GetSize ());
+  Buffer::Iterator iter = secondaryBuffer.Begin ();
+
+  iter.WriteU8 (GetType ());
+  iter.WriteU8 (GetCode ());
+  iter.WriteU16 (0);
+  iter.WriteHtonU32 (GetMtu ());
 
   uint32_t size = m_packet->GetSize ();
   uint8_t *buf = new uint8_t[size];
   m_packet->CopyData (buf, size);
-  i.Write (buf, size);
+  iter.Write (buf, size);
   delete[] buf;
 
-  i = start;
-  checksum = i.CalculateIpChecksum (i.GetSize (), GetChecksum ());
+  iter = secondaryBuffer.Begin ();
+  checksum = iter.CalculateIpChecksum (iter.GetSize (), GetChecksum ());
 
-  i = start;
-  i.Next (2);
+  i.WriteU8 (GetType ());
+  i.WriteU8 (GetCode ());
   i.WriteU16 (checksum);
+  i.WriteHtonU32 (GetMtu ());
 }
 
 uint32_t Icmpv6TooBig::Deserialize (Buffer::Iterator start) 
 {
   NS_LOG_FUNCTION (this << &start);
-  uint16_t length = start.GetRemainingSize () - 8;
-  uint8_t* data = new uint8_t[length];
   Buffer::Iterator i = start;
 
   SetType (i.ReadU8 ());
   SetCode (i.ReadU8 ());
   m_checksum = i.ReadU16 ();
   SetMtu (i.ReadNtohU32 ());
-  i.Read (data, length);
-  m_packet = Create<Packet> (data, length);
 
-  delete[] data;
   return GetSerializedSize ();
 }
 
@@ -1278,17 +1270,12 @@
   NS_LOG_FUNCTION (this);
 }
 
-Ptr<Packet> Icmpv6TimeExceeded::GetPacket () const 
-{
-  NS_LOG_FUNCTION (this);
-  return m_packet;
-}
 
 void Icmpv6TimeExceeded::SetPacket (Ptr<Packet> p) 
 {
   NS_LOG_FUNCTION (this << *p);
   NS_ASSERT (p->GetSize () <= 1280);
-  m_packet = p;
+  m_packet = p->Copy ();
 }
 
 void Icmpv6TimeExceeded::Print (std::ostream& os) const
@@ -1300,51 +1287,51 @@
 uint32_t Icmpv6TimeExceeded::GetSerializedSize () const
 {
   NS_LOG_FUNCTION (this);
-  return 8 + m_packet->GetSize ();
+  // The real size of the header is 8 + m_packet->GetSize ()
+  // HOWEVER we just serialize the first 8 bytes, as the rest is serialized separately.
+  return 8;
 }
 
 void Icmpv6TimeExceeded::Serialize (Buffer::Iterator start) const
 {
   NS_LOG_FUNCTION (this << &start);
-  
   uint16_t checksum = 0;
   Buffer::Iterator i = start;
 
-  i.WriteU8 (GetType ());
-  i.WriteU8 (GetCode ());
-  i.WriteHtonU16 (0);
-  i.WriteHtonU32 (0);
+  Buffer secondaryBuffer;
+  secondaryBuffer.AddAtStart (8 + m_packet->GetSize ());
+  Buffer::Iterator iter = secondaryBuffer.Begin ();
+
+  iter.WriteU8 (GetType ());
+  iter.WriteU8 (GetCode ());
+  iter.WriteU16 (0);
+  iter.WriteU32 (0);
 
   uint32_t size = m_packet->GetSize ();
   uint8_t *buf = new uint8_t[size];
   m_packet->CopyData (buf, size);
-  i.Write (buf, size);
+  iter.Write (buf, size);
   delete[] buf;
 
-  i = start;
-  checksum = i.CalculateIpChecksum (i.GetSize (), GetChecksum ());
+  iter = secondaryBuffer.Begin ();
+  checksum = iter.CalculateIpChecksum (iter.GetSize (), GetChecksum ());
 
-  i = start;
-  i.Next (2);
+  i.WriteU8 (GetType ());
+  i.WriteU8 (GetCode ());
   i.WriteU16 (checksum);
+  i.WriteU32 (0);
 }
 
 uint32_t Icmpv6TimeExceeded::Deserialize (Buffer::Iterator start)
 {
   NS_LOG_FUNCTION (this << &start);
-  
-  uint16_t length = start.GetRemainingSize () - 8;
-  uint8_t* data = new uint8_t[length];
   Buffer::Iterator i = start;
 
   SetType (i.ReadU8 ());
   SetCode (i.ReadU8 ());
   m_checksum = i.ReadU16 ();
-  i.ReadNtohU32 ();
-  i.Read (data, length);
-  m_packet = Create<Packet> (data, length);
+  i.ReadU32 ();
 
-  delete[] data;
   return GetSerializedSize ();
 }
 
@@ -1379,17 +1366,11 @@
   NS_LOG_FUNCTION (this);
 }
 
-Ptr<Packet> Icmpv6ParameterError::GetPacket () const
-{
-  NS_LOG_FUNCTION (this);
-  return m_packet;
-}
-
 void Icmpv6ParameterError::SetPacket (Ptr<Packet> p)
 {
   NS_LOG_FUNCTION (this << *p);
   NS_ASSERT (p->GetSize () <= 1280);
-  m_packet = p;
+  m_packet = p->Copy ();
 }
 
 uint32_t Icmpv6ParameterError::GetPtr () const
@@ -1413,7 +1394,9 @@
 uint32_t Icmpv6ParameterError::GetSerializedSize () const 
 {
   NS_LOG_FUNCTION (this);
-  return 8 + m_packet->GetSize ();
+  // The real size of the header is 8 + m_packet->GetSize ()
+  // HOWEVER we just serialize the first 8 bytes, as the rest is serialized separately.
+  return 8;
 }
 
 void Icmpv6ParameterError::Serialize (Buffer::Iterator start) const 
@@ -1422,39 +1405,39 @@
   uint16_t checksum = 0;
   Buffer::Iterator i = start;
 
-  i.WriteU8 (GetType ());
-  i.WriteU8 (GetCode ());
-  i.WriteHtonU16 (0);
-  i.WriteHtonU32 (GetPtr ());
+  Buffer secondaryBuffer;
+  secondaryBuffer.AddAtStart (8 + m_packet->GetSize ());
+  Buffer::Iterator iter = secondaryBuffer.Begin ();
+
+  iter.WriteU8 (GetType ());
+  iter.WriteU8 (GetCode ());
+  iter.WriteU16 (0);
+  iter.WriteHtonU32 (GetPtr ());
 
   uint32_t size = m_packet->GetSize ();
   uint8_t *buf = new uint8_t[size];
   m_packet->CopyData (buf, size);
-  i.Write (buf, size);
+  iter.Write (buf, size);
   delete[] buf;
 
-  i = start;
-  checksum = i.CalculateIpChecksum (i.GetSize (), GetChecksum ());
+  iter = secondaryBuffer.Begin ();
+  checksum = iter.CalculateIpChecksum (iter.GetSize (), GetChecksum ());
 
-  i = start;
-  i.Next (2);
+  i.WriteU8 (GetType ());
+  i.WriteU8 (GetCode ());
   i.WriteU16 (checksum);
+  i.WriteHtonU32 (GetPtr ());
 }
 
 uint32_t Icmpv6ParameterError::Deserialize (Buffer::Iterator start) 
 {
   NS_LOG_FUNCTION (this << &start);
-  uint16_t length = start.GetRemainingSize () - 8;
-  uint8_t* data = new uint8_t[length];
   Buffer::Iterator i = start;
 
   SetType (i.ReadU8 ());
   SetCode (i.ReadU8 ());
   m_checksum = i.ReadU16 ();
   SetPtr (i.ReadNtohU32 ());
-  i.Read (data, length);
-  m_packet = Create<Packet> (data, length);
-  delete[] data;
 
   return GetSerializedSize ();
 }
@@ -1949,17 +1932,11 @@
   m_packet = 0;
 }
 
-Ptr<Packet> Icmpv6OptionRedirected::GetPacket () const
-{
-  NS_LOG_FUNCTION (this);
-  return m_packet;
-}
-
 void Icmpv6OptionRedirected::SetPacket (Ptr<Packet> packet)
 {
   NS_LOG_FUNCTION (this << *packet);
   NS_ASSERT (packet->GetSize () <= 1280);
-  m_packet = packet;
+  m_packet = packet->Copy ();
   SetLength (1 + (m_packet->GetSize () / 8));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/icmpv6-header.h ns-3.36/src/internet/model/icmpv6-header.h
--- ns-3.35/src/internet/model/icmpv6-header.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/icmpv6-header.h	2022-04-30 18:23:57.862733600 -0700
@@ -1061,12 +1061,6 @@
   virtual TypeId GetInstanceTypeId () const;
 
   /**
-   * \brief Get the incorrect packet.
-   * \return the incorrect packet
-   */
-  Ptr<Packet> GetPacket () const;
-
-  /**
    * \brief Set the incorrect packet.
    * \param p the incorrect packet
    */
@@ -1135,12 +1129,6 @@
   virtual TypeId GetInstanceTypeId () const;
 
   /**
-   * \brief Get the incorrect packet.
-   * \return the incorrect packet
-   */
-  Ptr<Packet> GetPacket () const;
-
-  /**
    * \brief Set the incorrect packet.
    * \param p the incorrect packet
    */
@@ -1227,12 +1215,6 @@
   virtual TypeId GetInstanceTypeId () const;
 
   /**
-   * \brief Get the incorrect packet.
-   * \return the incorrect packet
-   */
-  Ptr<Packet> GetPacket () const;
-
-  /**
    * \brief Set the incorrect packet.
    * \param p the incorrect packet
    */
@@ -1302,12 +1284,6 @@
   virtual TypeId GetInstanceTypeId () const;
 
   /**
-   * \brief Get the incorrect packet.
-   * \return the incorrect packet
-   */
-  Ptr<Packet> GetPacket () const;
-
-  /**
    * \brief Set the incorrect packet.
    * \param p the incorrect packet
    */
@@ -1755,12 +1731,6 @@
   virtual ~Icmpv6OptionRedirected ();
 
   /**
-   * \brief Get the redirected packet.
-   * \return the redirected packet
-   */
-  Ptr<Packet> GetPacket () const;
-
-  /**
    * \brief Set the redirected packet.
    * \param packet the redirected packet
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/icmpv6-l4-protocol.cc ns-3.36/src/internet/model/icmpv6-l4-protocol.cc
--- ns-3.35/src/internet/model/icmpv6-l4-protocol.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/icmpv6-l4-protocol.cc	2022-04-30 18:23:57.862733600 -0700
@@ -881,14 +881,13 @@
 
   Icmpv6DestinationUnreachable unreach;
   pkt->RemoveHeader (unreach);
-  Ptr<Packet> origPkt = unreach.GetPacket ();
 
   Ipv6Header ipHeader;
-  if ( origPkt->GetSize () > ipHeader.GetSerializedSize () )
+  if (pkt->GetSize () > ipHeader.GetSerializedSize ())
     {
-      origPkt->RemoveHeader (ipHeader);
+      pkt->RemoveHeader (ipHeader);
       uint8_t payload[8];
-      origPkt->CopyData (payload, 8);
+      pkt->CopyData (payload, 8);
       Forward (src, unreach, unreach.GetCode (), ipHeader, payload);
     }
 }
@@ -900,13 +899,16 @@
 
   Icmpv6TimeExceeded timeexceeded;
   pkt->RemoveHeader (timeexceeded);
-  Ptr<Packet> origPkt = timeexceeded.GetPacket ();
-  Ipv6Header ipHeader;
-  uint8_t payload[8];
-  origPkt->RemoveHeader (ipHeader);
-  origPkt->CopyData (payload, 8);
 
-  Forward (src, timeexceeded, timeexceeded.GetCode (), ipHeader, payload);
+  Ipv6Header ipHeader;
+  if (pkt->GetSize () > ipHeader.GetSerializedSize ())
+    {
+      Ipv6Header ipHeader;
+      pkt->RemoveHeader (ipHeader);
+      uint8_t payload[8];
+      pkt->CopyData (payload, 8);
+      Forward (src, timeexceeded, timeexceeded.GetCode (), ipHeader, payload);
+    }
 }
 
 void Icmpv6L4Protocol::HandlePacketTooBig (Ptr<Packet> p, Ipv6Address const &src, Ipv6Address const &dst, Ptr<Ipv6Interface> interface)
@@ -916,17 +918,19 @@
 
   Icmpv6TooBig tooBig;
   pkt->RemoveHeader (tooBig);
-  Ptr<Packet> origPkt = tooBig.GetPacket ();
 
   Ipv6Header ipHeader;
-  origPkt->RemoveHeader (ipHeader);
-  uint8_t payload[8];
-  origPkt->CopyData (payload, 8);
+  if (pkt->GetSize () > ipHeader.GetSerializedSize ())
+    {
+      pkt->RemoveHeader (ipHeader);
+      uint8_t payload[8];
+      pkt->CopyData (payload, 8);
 
-  Ptr<Ipv6L3Protocol> ipv6 = m_node->GetObject<Ipv6L3Protocol> ();
-  ipv6->SetPmtu(ipHeader.GetDestination(), tooBig.GetMtu ());
+      Ptr<Ipv6L3Protocol> ipv6 = m_node->GetObject<Ipv6L3Protocol> ();
+      ipv6->SetPmtu (ipHeader.GetDestination (), tooBig.GetMtu ());
 
-  Forward (src, tooBig, tooBig.GetMtu (), ipHeader, payload);
+      Forward (src, tooBig, tooBig.GetMtu (), ipHeader, payload);
+    }
 }
 
 void Icmpv6L4Protocol::HandleParameterError (Ptr<Packet> p, Ipv6Address const &src, Ipv6Address const &dst, Ptr<Ipv6Interface> interface)
@@ -936,13 +940,15 @@
 
   Icmpv6ParameterError paramErr;
   pkt->RemoveHeader (paramErr);
-  Ptr<Packet> origPkt = paramErr.GetPacket ();
 
   Ipv6Header ipHeader;
-  origPkt->RemoveHeader (ipHeader);
-  uint8_t payload[8];
-  origPkt->CopyData (payload, 8);
-  Forward (src, paramErr, paramErr.GetCode (), ipHeader, payload);
+  if (pkt->GetSize () > ipHeader.GetSerializedSize ())
+    {
+      pkt->RemoveHeader (ipHeader);
+      uint8_t payload[8];
+      pkt->CopyData (payload, 8);
+      Forward (src, paramErr, paramErr.GetCode (), ipHeader, payload);
+    }
 }
 
 void Icmpv6L4Protocol::SendMessage (Ptr<Packet> packet, Ipv6Address src, Ipv6Address dst, uint8_t ttl)
@@ -1101,9 +1107,9 @@
 void Icmpv6L4Protocol::SendErrorDestinationUnreachable (Ptr<Packet> malformedPacket, Ipv6Address dst, uint8_t code)
 {
   NS_LOG_FUNCTION (this << malformedPacket << dst << (uint32_t)code);
-  Ptr<Packet> p = Create<Packet> ();
   uint32_t malformedPacketSize = malformedPacket->GetSize ();
   Icmpv6DestinationUnreachable header;
+  header.SetCode (code);
 
   NS_LOG_LOGIC ("Send Destination Unreachable ( to " << dst << " code " << (uint32_t)code << " )");
 
@@ -1111,23 +1117,23 @@
   if (malformedPacketSize <= 1280 - 48)
     {
       header.SetPacket (malformedPacket);
+      SendMessage (malformedPacket, dst, header, 255);
     }
   else
     {
       Ptr<Packet> fragment = malformedPacket->CreateFragment (0, 1280 - 48);
       header.SetPacket (fragment);
+      SendMessage (fragment, dst, header, 255);
     }
-
-  header.SetCode (code);
-  SendMessage (p, dst, header, 255);
 }
 
 void Icmpv6L4Protocol::SendErrorTooBig (Ptr<Packet> malformedPacket, Ipv6Address dst, uint32_t mtu)
 {
   NS_LOG_FUNCTION (this << malformedPacket << dst << mtu);
-  Ptr<Packet> p = Create<Packet> ();
   uint32_t malformedPacketSize = malformedPacket->GetSize ();
   Icmpv6TooBig header;
+  header.SetCode (0);
+  header.SetMtu (mtu);
 
   NS_LOG_LOGIC ("Send Too Big ( to " << dst << " )");
 
@@ -1135,24 +1141,22 @@
   if (malformedPacketSize <= 1280 - 48)
     {
       header.SetPacket (malformedPacket);
+      SendMessage (malformedPacket, dst, header, 255);
     }
   else
     {
       Ptr<Packet> fragment = malformedPacket->CreateFragment (0, 1280 - 48);
       header.SetPacket (fragment);
+      SendMessage (fragment, dst, header, 255);
     }
-
-  header.SetCode (0);
-  header.SetMtu (mtu);
-  SendMessage (p, dst, header, 255);
 }
 
 void Icmpv6L4Protocol::SendErrorTimeExceeded (Ptr<Packet> malformedPacket, Ipv6Address dst, uint8_t code)
 {
   NS_LOG_FUNCTION (this << malformedPacket << dst << static_cast<uint32_t> (code));
-  Ptr<Packet> p = Create<Packet> ();
   uint32_t malformedPacketSize = malformedPacket->GetSize ();
   Icmpv6TimeExceeded header;
+  header.SetCode (code);
 
   NS_LOG_LOGIC ("Send Time Exceeded ( to " << dst << " code " << (uint32_t)code << " )");
 
@@ -1160,23 +1164,23 @@
   if (malformedPacketSize <= 1280 - 48)
     {
       header.SetPacket (malformedPacket);
+      SendMessage (malformedPacket, dst, header, 255);
     }
   else
     {
       Ptr<Packet> fragment = malformedPacket->CreateFragment (0, 1280 - 48);
       header.SetPacket (fragment);
+      SendMessage (fragment, dst, header, 255);
     }
-
-  header.SetCode (code);
-  SendMessage (p, dst, header, 255);
 }
 
 void Icmpv6L4Protocol::SendErrorParameterError (Ptr<Packet> malformedPacket, Ipv6Address dst, uint8_t code, uint32_t ptr)
 {
   NS_LOG_FUNCTION (this << malformedPacket << dst << static_cast<uint32_t> (code) << ptr);
-  Ptr<Packet> p = Create<Packet> ();
   uint32_t malformedPacketSize = malformedPacket->GetSize ();
   Icmpv6ParameterError header;
+  header.SetCode (code);
+  header.SetPtr (ptr);
 
   NS_LOG_LOGIC ("Send Parameter Error ( to " << dst << " code " << (uint32_t)code << " )");
 
@@ -1184,16 +1188,14 @@
   if (malformedPacketSize <= 1280 - 48 )
     {
       header.SetPacket (malformedPacket);
+      SendMessage (malformedPacket, dst, header, 255);
     }
   else
     {
       Ptr<Packet> fragment = malformedPacket->CreateFragment (0, 1280 - 48);
       header.SetPacket (fragment);
+      SendMessage (fragment, dst, header, 255);
     }
-
-  header.SetCode (code);
-  header.SetPtr (ptr);
-  SendMessage (p, dst, header, 255);
 }
 
 void Icmpv6L4Protocol::SendRedirection (Ptr<Packet> redirectedPacket, Ipv6Address src, Ipv6Address dst, Ipv6Address redirTarget, Ipv6Address redirDestination, Address redirHardwareTarget)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv4-interface.h ns-3.36/src/internet/model/ipv4-interface.h
--- ns-3.35/src/internet/model/ipv4-interface.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv4-interface.h	2022-04-30 18:23:57.866733600 -0700
@@ -62,6 +62,10 @@
   Ipv4Interface ();
   virtual ~Ipv4Interface();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  Ipv4Interface (const Ipv4Interface &) = delete;
+  Ipv4Interface & operator = (const Ipv4Interface &) = delete;
+
   /**
    * \brief Set node associated with interface.
    * \param node node
@@ -190,24 +194,8 @@
 
 protected:
   virtual void DoDispose (void);
-private:
-  /**
-   * \brief Copy constructor
-   * \param o object to copy
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv4Interface (const Ipv4Interface &o);
-
-  /**
-   * \brief Assignment operator
-   * \param o object to copy
-   * \returns the copied object
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Ipv4Interface &operator = (const Ipv4Interface &o);
 
+private:
   /**
    * \brief Initialize interface.
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/ipv4-l3-protocol.cc ns-3.36/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.35/src/internet/model/ipv4-l3-protocol.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/ipv4-l3-protocol.cc	2022-04-30 18:23:57.866733600 -0700
@@ -585,14 +585,14 @@
 
   if (ipv4Interface->IsUp ())
     {
-      m_rxTrace (packet, m_node->GetObject<Ipv4> (), interface);
+      m_rxTrace (packet, this, interface);
     }
   else
     {
       NS_LOG_LOGIC ("Dropping received packet -- interface is down");
       Ipv4Header ipHeader;
       packet->RemoveHeader (ipHeader);
-      m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, m_node->GetObject<Ipv4> (), interface);
+      m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, this, interface);
       return;
     }
 
@@ -612,7 +612,7 @@
   if (!ipHeader.IsChecksumOk ()) 
     {
       NS_LOG_LOGIC ("Dropping received packet -- checksum not ok");
-      m_dropTrace (ipHeader, packet, DROP_BAD_CHECKSUM, m_node->GetObject<Ipv4> (), interface);
+      m_dropTrace (ipHeader, packet, DROP_BAD_CHECKSUM, this, interface);
       return;
     }
 
@@ -656,7 +656,7 @@
   if (m_enableDpd && ipHeader.GetDestination ().IsMulticast () && UpdateDuplicate (packet, ipHeader))
     {
       NS_LOG_LOGIC ("Dropping received packet -- duplicate.");
-      m_dropTrace (ipHeader, packet, DROP_DUPLICATE, m_node->GetObject<Ipv4> (), interface);
+      m_dropTrace (ipHeader, packet, DROP_DUPLICATE, this, interface);
       return;
     }
 
@@ -669,7 +669,7 @@
                                       ))
     {
       NS_LOG_WARN ("No route found for forwarding packet.  Drop.");
-      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, m_node->GetObject<Ipv4> (), interface);
+      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, this, interface);
     }
 }
 
@@ -741,9 +741,12 @@
 Ipv4L3Protocol::CallTxTrace (const Ipv4Header & ipHeader, Ptr<Packet> packet,
                                     Ptr<Ipv4> ipv4, uint32_t interface)
 {
-  Ptr<Packet> packetCopy = packet->Copy ();
-  packetCopy->AddHeader (ipHeader);
-  m_txTrace (packetCopy, ipv4, interface);
+  if (!m_txTrace.IsEmpty ())
+    {
+      Ptr<Packet> packetCopy = packet->Copy ();
+      packetCopy->AddHeader (ipHeader);
+      m_txTrace (packetCopy, ipv4, interface);
+    }
 }
 
 void 
@@ -895,7 +898,7 @@
   else
     {
       NS_LOG_WARN ("No route to host.  Drop.");
-      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, m_node->GetObject<Ipv4> (), 0);
+      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, this, 0);
       DecreaseIdentification (source, destination, protocol);
     }
 }
@@ -968,7 +971,7 @@
   if (route == 0)
     {
       NS_LOG_WARN ("No route to host.  Drop.");
-      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, m_node->GetObject<Ipv4> (), 0);
+      m_dropTrace (ipHeader, packet, DROP_NO_ROUTE, this, 0);
       return;
     }
   Ptr<NetDevice> outDev = route->GetOutputDevice ();
@@ -1000,13 +1003,13 @@
           for ( std::list<Ipv4PayloadHeaderPair>::iterator it = listFragments.begin (); it != listFragments.end (); it++ )
             {
               NS_LOG_LOGIC ("Sending fragment " << *(it->first) );
-              CallTxTrace (it->second, it->first, m_node->GetObject<Ipv4> (), interface);
+              CallTxTrace (it->second, it->first, this, interface);
               outInterface->Send (it->first, it->second, target);
             }
         }
       else
         {
-          CallTxTrace (ipHeader, packet, m_node->GetObject<Ipv4> (), interface);
+          CallTxTrace (ipHeader, packet, this, interface);
           outInterface->Send (packet, ipHeader, target);
         }
     }
@@ -1033,7 +1036,7 @@
       if (ipHeader.GetTtl () == 0)
         {
           NS_LOG_WARN ("TTL exceeded.  Drop.");
-          m_dropTrace (header, packet, DROP_TTL_EXPIRED, m_node->GetObject<Ipv4> (), interface);
+          m_dropTrace (header, packet, DROP_TTL_EXPIRED, this, interface);
           return;
         }
       NS_LOG_LOGIC ("Forward multicast via interface " << interface);
@@ -1070,7 +1073,7 @@
           icmp->SendTimeExceededTtl (ipHeader, packet, false);
         }
       NS_LOG_WARN ("TTL exceeded.  Drop.");
-      m_dropTrace (header, packet, DROP_TTL_EXPIRED, m_node->GetObject<Ipv4> (), interface);
+      m_dropTrace (header, packet, DROP_TTL_EXPIRED, this, interface);
       return;
     }
   // in case the packet still has a priority tag attached, remove it
@@ -1431,7 +1434,7 @@
 {
   NS_LOG_FUNCTION (this << p << ipHeader << sockErrno);
   NS_LOG_LOGIC ("Route input failure-- dropping packet to " << ipHeader << " with errno " << sockErrno); 
-  m_dropTrace (ipHeader, p, DROP_ROUTE_ERROR, m_node->GetObject<Ipv4> (), 0);
+  m_dropTrace (ipHeader, p, DROP_ROUTE_ERROR, this, 0);
 
   // \todo Send an ICMP no route.
 }
@@ -1731,7 +1734,7 @@
       Ptr<Icmpv4L4Protocol> icmp = GetIcmp ();
       icmp->SendTimeExceededTtl (ipHeader, packet, true);
     }
-  m_dropTrace (ipHeader, packet, DROP_FRAGMENT_TIMEOUT, m_node->GetObject<Ipv4> (), iif);
+  m_dropTrace (ipHeader, packet, DROP_FRAGMENT_TIMEOUT, this, iif);
 
   // clear the buffers
   it->second = 0;
